--- old/usr/src/uts/Makefile.uts	Mon Sep  2 08:41:56 2019
+++ new/usr/src/uts/Makefile.uts	Mon Sep  2 08:41:56 2019
@@ -25,7 +25,7 @@
 # Copyright (c) 2011,2017 by Delphix. All rights reserved.
 # Copyright (c) 2013 Andrew Stormont.  All rights reserved.
 # Copyright 2016 Hans Rosenfeld <rosenfeld@grumpf.hope-2000.org>
-# Copyright (c) 2019, Joyent, Inc.
+# Copyright 2019 Joyent, Inc.
 #
 
 #
@@ -241,6 +241,14 @@
 #
 SMOFF += sizeof
 
+#
+# Ensure that the standard function prologue remains at the very start of a function,
+# so DTrace fbt will instrument the right place.
+#
+CFLAGS_uts_i386 += -_gcc7=-fno-shrink-wrap
+CFLAGS_uts_i386 += -_gcc8=-fno-shrink-wrap
+CFLAGS_uts_i386 += -_gcc9=-fno-shrink-wrap
+
 CSTD = $(CSTD_GNU99)
 
 CFLAGS_uts		=
@@ -257,6 +265,7 @@
 CFLAGS_uts		+= $(EXTRA_CFLAGS)
 CFLAGS_uts		+= $(CSOURCEDEBUGFLAGS)
 CFLAGS_uts		+= $(CUSERFLAGS)
+CFLAGS_uts		+= $(CFLAGS_uts_$(MACH))
 
 #
 #	Declare that $(OBJECTS) and $(LINTS) can be compiled in parallel.
